/**
 * auth_set.dart
 * Circumstellar - Models/Misc
 * 
 * Created by Jackson Rakena
 * Copyright (c) 2018 Jackson Rakena. All rights reserved.
 * Part of the Circumstellar project, licensed under a 3-Clause BSD License (under LICENSE)
 */

part of circumstellar;

/// Represents neccesary secret values to connect to Discord.
class DiscordAuthSet {
  /// The Discord Bot User Token (or user/webhook token) to connect with.
  String token;

  /// The type of the token provided.
  TokenType tokenType;

  /// Default constructor.
  DiscordAuthSet(this.token, this.tokenType);
}

/// The type of token to connect with. You probably want to use Bot.
enum TokenType { Bot, User, Webhook, Bearer }
