/**
 * channel_selector.dart
 * Circumstellar - Models/Channel
 * 
 * Created by Jackson Rakena
 * Copyright (c) 2018 Jackson Rakena. All rights reserved.
 * Part of the Circumstellar project, licensed under a 3-Clause BSD License (under LICENSE)
 */

import 'package:circumstellar/circumstellar.dart';
import 'dart:async';

/// Library utilities to help in determining a channel's type
class ChannelSelector {
  /// Creates a new [BaseChannel] with the appropriate type from a JSON channel object.
  static Future<BaseChannel> fromJson(
      Map<String, dynamic> json, DiscordClient client) async {
    switch (json['type']) {
      case 0:
        // Guild text
        return client.entities.getEntity(json['id'], 'GuildTextChannel');
      case 1:
        // DM
        break;
      case 2:
        // Guild voice
        break;
      case 3:
        // Group DM
        break;
      case 4:
        // Guild category
        break;
      default:
        return null;
    }
    return null;
  }
}
