/**
 * entity.dart
 * Circumstellar - Models
 * 
 * Created by Jackson Rakena
 * Copyright (c) 2018 Jackson Rakena. All rights reserved.
 * Part of the Circumstellar project, licensed under a 3-Clause BSD License (under LICENSE)
 */

part of circumstellar;

/// Represents a generic Discord entity with an ID.
abstract class Entity {
  /// ID of this entity (usually a snowflake converted to a string)
  String id;

  /// The [DiscordClient] this entity belongs to.
  DiscordClient client;

  /// The raw data used to construct this entity.
  Map<String, dynamic> rawData;

  /// Updates this entity based on new JSON data.
  Future updateModel(Map<String, dynamic> json, DiscordClient client) async {
    this.id = json['id'];
  }

  /// Creates a blank entity.
  Entity(this.client);
}
