/**
 * images.dart
 * Circumstellar - Client Utilities
 * 
 * Created by Jackson Rakena
 * Copyright (c) 2018 Jackson Rakena. All rights reserved.
 * Part of the Circumstellar project, licensed under a 3-Clause BSD License (under LICENSE)
 */

part of circumstellar;

/// A helper class to retrieve images from the Discord CDN.
class CDNImageHelper {
  static String imageBaseUrl = "https://cdn.discordapp.com/";

  static String customEmojiEndpoint(String emojiId, String format) =>
      imageBaseUrl + "emojis/$emojiId.$format";

  static String guildIconEndpoint(
          String guildId, String guildIconHash, String format) =>
      imageBaseUrl + "icons/$guildId/$guildIconHash.$format";

  static String guildSplashEndpoint(
          String guildId, String guildSplashHash, String format) =>
      imageBaseUrl + "splashes/$guildId/$guildSplashHash.$format";

  static String defaultUserAvatarEndpoint(
          int userDiscriminator, String format) =>
      imageBaseUrl + "embed/avatars/${(userDiscriminator % 5)}.$format";

  static String userAvatarEndpoint(
          String userId, String userAvatarHash, String format) =>
      imageBaseUrl + "avatars/$userId/$userAvatarHash.$format";

  static String applicationIconEndpoint(
          String applicationId, String applicationIconHash, String format) =>
      imageBaseUrl + "app-icons/$applicationId/$applicationIconHash.$format";
}
